<?php
namespace UltimateEmailValidator;


if ( ! defined( 'ABSPATH' ) ) {
	exit; // Exit if accessed directly.
}


/**
 *
 * Collect all controls of section [ general ]
 *
 * @version 1.0
 *
 * @author Oxibug
 *
 */
class AdminPanelTab_Admin {

    /**
     * Local instance to save the the class's object
     * after instantiated
     *
     * @var AdminPanelTab_Admin
     */
    private static $_instance = null;

    /**
     * Instantiate an object from class
     *
     * @return AdminPanelTab_Admin
     */
    public static function instance() {

        if( is_null( self::$_instance ) ) {

            self::$_instance = new self;

        }

        return self::$_instance;

    }

    /**
     * Silent Constructor
     *
     * */
    private function __construct() { }


    public function tab_wordpress_functions() {

        return array(

            array( 'id'     => 'sw_wp_filter_func_is_email',
                'title'     => esc_html__('Filter {is_email} function permanently?', ULTIMATE_EMAIL_VALIDATOR_TEXTDOMAIN),
                'description'   => wp_kses_post( sprintf( __('If you checked that option it will affect all functions use {%1$s} function,<br/><br/>
                    The default is {unchecked} to display your custom message, Otherwise you\'ll notice that the custom message will not be displayed because the function {%1$s} fired early.', ULTIMATE_EMAIL_VALIDATOR_TEXTDOMAIN ), 'is_email' ) ),

                'type'      => 'checkbox',
                'default'   => false,
                'params'    => array(
                    'priority'  => 10,
                )

            ),

            array( 'id'     => 'sw_wp_filter_func_is_email_address_unsafe',
                'title'     => esc_html__('Filter {is_email_address_unsafe} function permanently?', ULTIMATE_EMAIL_VALIDATOR_TEXTDOMAIN),
                'description'   => wp_kses_post( sprintf( __('If you checked that option it will affect all functions use {%1$s} function,<br/><br/>
                    The default is {unchecked} to display your custom message, Otherwise you\'ll notice that the custom message will not be displayed because the function {%1$s} fired early.', ULTIMATE_EMAIL_VALIDATOR_TEXTDOMAIN ), 'is_email_address_unsafe' ) ),

                'type'      => 'checkbox',
                'default'   => false,
                'params'    => array(
                    'priority'  => 20,
                )

            ),

        );

    }


    public function tab_wordpress_forms() {

        return array(


            array( 'id'     => 'sw_wp_validate_email_on_registration',
                'title'     => esc_html__('Validate the user email in the registration form?', ULTIMATE_EMAIL_VALIDATOR_TEXTDOMAIN),
                'description'   => wp_kses_post( __('Check the user email before registration done and display the following message if he use a disposable email.', ULTIMATE_EMAIL_VALIDATOR_TEXTDOMAIN ) ),

                'type'      => 'checkbox',
                'default'   => true,
                'params'    => array(
                    'priority'  => 30,
                )

            ),
            array( 'id'     => 'txt_wp_registration_form_message',
                'title'     => esc_html__('WordPress Registration Form - Error Message.', ULTIMATE_EMAIL_VALIDATOR_TEXTDOMAIN),
                'description'   => wp_kses_post( sprintf( __( 'Enter a message to notify your user that he cannot use a disposable email address.<br/><br/>
                    That will be affected if you choose to filter the following functions.<br/>%s.<br/>%s.', ULTIMATE_EMAIL_VALIDATOR_TEXTDOMAIN ), 'is_email', 'is_email_address_unsafe' ) ),

                'type'      => 'textarea',
                'default'   => wp_kses_post( __( 'You can\'t use that email address to signup because it marked as a <b>disposable</b>, Please use another email provider.', ULTIMATE_EMAIL_VALIDATOR_TEXTDOMAIN ) ),
                'params'    => array(
                    'priority'  => 40,
                )

            ),

            array( 'id'     => 'sw_wp_validate_email_on_post_comment',
                'title'     => esc_html__('Validate the user email on post a comment?', ULTIMATE_EMAIL_VALIDATOR_TEXTDOMAIN),
                'description'   => wp_kses_post( __('Check the user email before the comment is posted. (The WordPress Default message will be displayed).', ULTIMATE_EMAIL_VALIDATOR_TEXTDOMAIN ) ),

                'type'      => 'checkbox',
                'default'   => true,
                'params'    => array(
                    'priority'  => 50,
                )

            ),

            array( 'id'     => 'sw_wp_validate_email_on_update_profile',
                'title'     => esc_html__('Validate the user email on update user profile?', ULTIMATE_EMAIL_VALIDATOR_TEXTDOMAIN),
                'description'   => wp_kses_post( __('Check the user email before the user profile updated. (The WordPress Default message will be displayed).', ULTIMATE_EMAIL_VALIDATOR_TEXTDOMAIN ) ),

                'type'      => 'checkbox',
                'default'   => true,
                'params'    => array(
                    'priority'  => 60,
                )

            ),
            array( 'id'     => 'txt_wp_update_profile_message',
                'title'     => esc_html__('Update Profile Form - Error Message.', ULTIMATE_EMAIL_VALIDATOR_TEXTDOMAIN),
                'description'   => wp_kses_post( sprintf( __( 'Enter a message to notify your user that he cannot use a disposable email address.<br/><br/>
                    That will be affected if you choose to filter the following functions.<br/>%s.<br/>%s.', ULTIMATE_EMAIL_VALIDATOR_TEXTDOMAIN ), 'is_email', 'is_email_address_unsafe' ) ),

                'type'      => 'textarea',
                'default'   => wp_kses_post( __( 'You can\'t modify your email address with a <b>disposable</b> email address, Please use another email provider.', ULTIMATE_EMAIL_VALIDATOR_TEXTDOMAIN ) ),
                'params'    => array(
                    'priority'  => 70,
                )

            ),


        );

    }


    public function tab_buddypress() {

        return array(

            array( 'id'     => 'sw_bp_validate_email_on_registration',
                'title'     => esc_html__('Validate the user email in the BuddyPress registration form?', ULTIMATE_EMAIL_VALIDATOR_TEXTDOMAIN),
                'description'   => wp_kses_post( __('Check the user email before registration done and display the following message if he use a disposable email.', ULTIMATE_EMAIL_VALIDATOR_TEXTDOMAIN ) ),

                'type'      => 'checkbox',
                'default'   => true,
                'params'    => array(
                    'priority'  => 10,
                )

            ),

            array( 'id'     => 'txt_bp_registration_form_message',
                'title'     => esc_html__('BuddyPress Registration Form - Error Message.', ULTIMATE_EMAIL_VALIDATOR_TEXTDOMAIN),
                'description'   => wp_kses_post( sprintf( __( 'Enter a message to notify your user that he cannot use a disposable email address.<br/><br/>
                    That will be affected if you choose to filter the following functions.<br/>%s.<br/>%s.', ULTIMATE_EMAIL_VALIDATOR_TEXTDOMAIN ), 'is_email', 'is_email_address_unsafe' ) ),

                'type'      => 'textarea',
                'default'   => wp_kses_post( __( 'You can\'t use that email address to signup because it marked as a disposable, Please use another email provider.', ULTIMATE_EMAIL_VALIDATOR_TEXTDOMAIN ) ),
                'params'    => array(
                    'priority'  => 20,
                )

            ),

        );

    }


    /**
     * The elements array of WooCommerce
     *
     * @return  array
     *
     * @since   1.0.0
     * @access  public
     */
    public function tab_woocommerce() {

        return array(

            array( 'id'     => 'sw_wc_validate_email_on_registration',
                'title'     => esc_html__('Validate the user email in the (WooCommerce) form?', ULTIMATE_EMAIL_VALIDATOR_TEXTDOMAIN),
                'description'   => wp_kses_post( __('Check the user email before registration done and display the following message if he use a disposable email.', ULTIMATE_EMAIL_VALIDATOR_TEXTDOMAIN ) ),

                'type'      => 'checkbox',
                'default'   => true,
                'params'    => array(
                    'priority'  => 10,
                )

            ),

            array( 'id'     => 'txt_wc_registration_form_message',
                'title'     => esc_html__('Using Disposable Email Address Error Message.', ULTIMATE_EMAIL_VALIDATOR_TEXTDOMAIN),
                'description'   => wp_kses_post( sprintf( __( 'Enter a message to notify your user that he cannot use a disposable email address.<br/><br/>
                    That will be affected if you choose to filter the following functions.<br/>%s.<br/>%s.', ULTIMATE_EMAIL_VALIDATOR_TEXTDOMAIN ), 'is_email', 'is_email_address_unsafe' ) ),

                'type'      => 'textarea',
                'default'   => wp_kses_post( __( 'You can\'t use that email address to signup because it marked as a <b>disposable</b>, Please use another email provider.', ULTIMATE_EMAIL_VALIDATOR_TEXTDOMAIN ) ),
                'params'    => array(
                    'priority'  => 20,
                )

            ),

            array( 'id'     => 'txt_wc_update_profile_message',
                'title'     => esc_html__('Update Profile Form - Error Message.', ULTIMATE_EMAIL_VALIDATOR_TEXTDOMAIN),
                'description'   => wp_kses_post( sprintf( __( 'Enter a message to notify your user that he cannot use a disposable email address.<br/><br/>
                    That will be affected if you choose to filter the following functions.<br/>%s.<br/>%s.', ULTIMATE_EMAIL_VALIDATOR_TEXTDOMAIN ), 'is_email', 'is_email_address_unsafe' ) ),

                'type'      => 'textarea',
                'default'   => wp_kses_post( __( 'You can\'t modify your email address with a <b>disposable</b> email address, Please use another email provider.', ULTIMATE_EMAIL_VALIDATOR_TEXTDOMAIN ) ),
                'params'    => array(
                    'priority'  => 20,
                )

            ),

        );

    }


    /**
     * The elements array of Contact Form 7
     *
     * @return  array
     *
     * @since   1.0.0
     * @access  public
     */
    public function tab_contactform7() {

        return array(

            array( 'id'     => 'sw_cf7_validate_email',
                'title'     => esc_html__('Validate the user email in the (Contact Form 7) form?', ULTIMATE_EMAIL_VALIDATOR_TEXTDOMAIN),
                'description'   => wp_kses_post( __('Check the user email before registration done and display the following message if he use a disposable email.', ULTIMATE_EMAIL_VALIDATOR_TEXTDOMAIN ) ),

                'type'      => 'checkbox',
                'default'   => true,
                'params'    => array(
                    'priority'  => 10,
                )

            ),

            array( 'id'     => 'txt_cf7_form_message',
                'title'     => esc_html__('Using Disposable Email Address Error Message.', ULTIMATE_EMAIL_VALIDATOR_TEXTDOMAIN),
                'description'   => esc_html__( 'Enter a message to notify your user that he cannot use a disposable email address.', ULTIMATE_EMAIL_VALIDATOR_TEXTDOMAIN ),

                'type'      => 'textarea',
                'default'   => wp_kses_post( __( 'Your email is marked as a disposable, Please use a real email to be able to reach you.', ULTIMATE_EMAIL_VALIDATOR_TEXTDOMAIN ) ),
                'params'    => array(
                    'priority'  => 20,
                )

            ),

        );

    }

    /**
     * The elements array of MailChimp
     *
     * @return  array
     *
     * @since   1.0.0
     * @access  public
     */
    public function tab_mailchimp() {

        return array(

            array( 'id'     => 'sw_mc4wp_validate_email',
                'title'     => esc_html__('Validate the user email in the (MailChimp) form?', ULTIMATE_EMAIL_VALIDATOR_TEXTDOMAIN),
                'description'   => wp_kses_post( __('Check the user email before registration done and display the following message if he use a disposable email.', ULTIMATE_EMAIL_VALIDATOR_TEXTDOMAIN ) ),

                'type'      => 'checkbox',
                'default'   => true,
                'params'    => array(
                    'priority'  => 10,
                )

            ),

            array( 'id'     => 'txt_mc4wp_form_message',
                'title'     => esc_html__('Using Disposable Email Address Error Message.', ULTIMATE_EMAIL_VALIDATOR_TEXTDOMAIN),
                'description'   => esc_html__( 'Enter a message to notify your user that he cannot use a disposable email address.', ULTIMATE_EMAIL_VALIDATOR_TEXTDOMAIN ),

                'type'      => 'textarea',
                'default'   => wp_kses_post( __( 'Your email is marked as a disposable, Please use a real email to be able to reach you.', ULTIMATE_EMAIL_VALIDATOR_TEXTDOMAIN ) ),
                'params'    => array(
                    'priority'  => 20,
                )

            ),

        );

    }


    /**
     * The elements array of Gravity Forms
     *
     * @return  array
     *
     * @since   1.0.0
     * @access  public
     */
    public function tab_gravityforms() {

        return array(

            array( 'id'     => 'sw_gravityforms_validate_email',
                'title'     => esc_html__('Validate the user email in the (Gravity Forms) form?', ULTIMATE_EMAIL_VALIDATOR_TEXTDOMAIN),
                'description'   => wp_kses_post( __('Check the user email before registration done and display the following message if he use a disposable email.', ULTIMATE_EMAIL_VALIDATOR_TEXTDOMAIN ) ),

                'type'      => 'checkbox',
                'default'   => true,
                'params'    => array(
                    'priority'  => 10,
                )

            ),

            array( 'id'     => 'txt_gravityforms_form_message',
                'title'     => esc_html__('Using Disposable Email Address Error Message.', ULTIMATE_EMAIL_VALIDATOR_TEXTDOMAIN),
                'description'   => esc_html__( 'Enter a message to notify your user that he cannot use a disposable email address.', ULTIMATE_EMAIL_VALIDATOR_TEXTDOMAIN ),

                'type'      => 'textarea',
                'default'   => wp_kses_post( __( 'Your email is marked as a disposable, Please use a real email to be able to reach you.', ULTIMATE_EMAIL_VALIDATOR_TEXTDOMAIN ) ),
                'params'    => array(
                    'priority'  => 20,
                )

            ),

        );

    }


    /**
     * The elements array of Ninja Forms
     *
     * @return  array
     *
     * @since   1.0.0
     * @access  public
     */
    public function tab_ninjaforms() {

        return array(

            array( 'id'     => 'sw_ninjaforms_validate_email',
                'title'     => esc_html__('Validate the user email in the (Ninja Forms) form?', ULTIMATE_EMAIL_VALIDATOR_TEXTDOMAIN),
                'description'   => wp_kses_post( __('Check the user email before registration done and display the following message if he use a disposable email.', ULTIMATE_EMAIL_VALIDATOR_TEXTDOMAIN ) ),

                'type'      => 'checkbox',
                'default'   => true,
                'params'    => array(
                    'priority'  => 10,
                )

            ),

            array( 'id'     => 'txt_ninjaforms_form_message',
                'title'     => esc_html__('Using Disposable Email Address Error Message.', ULTIMATE_EMAIL_VALIDATOR_TEXTDOMAIN),
                'description'   => esc_html__( 'Enter a message to notify your user that he cannot use a disposable email address.', ULTIMATE_EMAIL_VALIDATOR_TEXTDOMAIN ),

                'type'      => 'textarea',
                'default'   => wp_kses_post( __( 'Your email is marked as a disposable, Please use a real email to be able to reach you.', ULTIMATE_EMAIL_VALIDATOR_TEXTDOMAIN ) ),
                'params'    => array(
                    'priority'  => 20,
                )

            ),

        );

    }



}